
Name:           onnx-optimizer
Version:        0.3.16
Release:        1%{?dist}
Summary:        Open Neural Network Exchange Optimizer
License:        Apache

URL:            https://github.com/onnx/optimizer
Source0:        optimizer-0.3.16.tar.xz 

BuildRequires:  doxygen cmake gcc-c++ protobuf-devel pybind11-devel
BuildRequires:  python3-devel python3-setuptools python3-pytest-runner onnx-devel


%description
Open Neural Network Exchange Optimizer

%package devel
Summary: Development files for onnx
Requires: %{name} = %{version}-%{release}

%description devel
This package contains development files for onnx.


%package python3
Summary: Python files for onnx
Requires: %{name} = %{version}-%{release}

%description python3
This package contains python files for onnx.


%prep
%setup -q -n optimizer-%{version}
rm -rf third_party/onnx

%build
# ver
sed -i 's|VERSION 3.22|VERSION 3.20|g' CMakeLists.txt
# ext
rm -rf third_party/onnx
rm -rf third_party/protobuf
sed -i '/third_party\/protobuf/d' CMakeLists.txt
sed -i '/add_subdirectory.*(${ONNX_ROOT}/d' CMakeLists.txt
sed -i '/Utils.cmake/d' cmake/utils.cmake
# ext flags
sed -i 's|onnx_optimizer PUBLIC ${ONNX_TARGET_NAME}|onnx_optimizer PUBLIC ${ONNX_TARGET_NAME} protobuf onnx_proto|g' CMakeLists.txt
%if 0%{?rhel}
sed -i 's|onnx_optimizer PUBLIC ${ONNX_TARGET_NAME}|onnx_optimizer PUBLIC ${ONNX_TARGET_NAME} stdc++fs|g' CMakeLists.txt
%endif
# build
export ONNX_ML=0
export ONNX_NAMESPACE=onnx
export CXXFLAGS="%{optflags} -DONNX_NAMESPACE=onnx"
export CMAKE_ARGS="-DCMAKE_VERBOSE_MAKEFILE:BOOL=ON -DCMAKE_INSTALL_PREFIX:PATH=/usr -DBUILD_SHARED_LIBS:BOOL=ON -DCMAKE_SKIP_RPATH=ON -DCMAKE_VERBOSE_MAKEFILE=OFF -DCMAKE_BUILD_TYPE=RelWithDebug"
%{__python3} setup.py build %{?_smp_mflags}


%install
pushd .setuptools-cmake-build
make install DESTDIR=%{buildroot}
popd

export ONNX_ML=0
export ONNX_NAMESPACE=onnx
export CXXFLAGS="%{optflags} -DONNX_NAMESPACE=onnx"
export CMAKE_ARGS="-DCMAKE_VERBOSE_MAKEFILE:BOOL=ON -DCMAKE_INSTALL_PREFIX:PATH=/usr -DBUILD_SHARED_LIBS:BOOL=ON -DCMAKE_SKIP_RPATH=ON -DCMAKE_VERBOSE_MAKEFILE=OFF -DCMAKE_BUILD_TYPE=RelWithDebug"
%{__python3} setup.py install --root %{buildroot}


mkdir -p %{buildroot}/%{_bindir}
mkdir -p %{buildroot}/%{_includedir}/onnx
ln -sf %{_includedir}/onnxoptimizer %{buildroot}/%{_includedir}/onnx/optimizer
install -pm 0755 .setuptools-cmake-build/onnx_optimizer_exec %{buildroot}/%{_bindir}/

sed -i 's|[<=>].*||g' %{buildroot}%{python3_sitearch}/*.egg-info/requires.txt


%files
%doc README.md
%license LICENSE
%{_bindir}/*
%{_libdir}/lib*.so*

%files devel
%{_includedir}/*
%{_libdir}/cmake/*

%files python3
%{python3_sitearch}/*


%changelog
* Fri Jun 16 2023 forrest_ly <flin@linux.alibaba.com> - 0.3.16-1
- init for anolis 23
